////////////////////////////////////
// Before | After Image Slider v1 //
////////////////////////////////////


var targetImageBefore;
var targetImageAfter;


///////////////////////////////////////////////////////////////////
// The Init function is called when bric is first selected       //
// Use it to make changes to the initial state of the sidebar UI //
///////////////////////////////////////////////////////////////////

function init(bricVersion)
{
	targetImageBefore = $('editarea .before-img');
	targetImageAfter = $('editarea .after-img');

	var imgPath = targetImageBefore.attr('src');
	var imgPathX2 = '';
	var imgPathX3 = '';

	var imgPathAfter = targetImageAfter.attr('src');
	var imgPathAfterX2 = '';
	var imgPathAfterX3 = '';
	
	if(targetImageBefore.hasAttr('src-2')) // Has @2x Image Set
	{
		imgPathX2 = targetImageBefore.attr('src-2');
	}
	
	if(targetImageBefore.hasAttr('src-3')) // Has @3x Image Set
	{
		imgPathX3 = targetImageBefore.attr('src-3');
	}

	if(targetImageAfter.hasAttr('src-2')) // After Has @2x Image Set
	{
		imgPathAfterX2 = targetImageAfter.attr('src-2');
	}
	
	if(targetImageAfter.hasAttr('src-3')) // After Has @3x Image Set
	{
		imgPathAfterX3 = targetImageAfter.attr('src-3');
	}
	
	// Set Image thumbnail
	window.webkit.messageHandlers.setUIVal.postMessage('{"attr":"before-image","value":"'+imgPath+'","sync":"false","imageRes":"1","image2x":"'+imgPathX2+'","image3x":"'+imgPathX3+'"}'); 
	window.webkit.messageHandlers.setUIVal.postMessage('{"attr":"after-image","value":"'+imgPathAfter+'","sync":"false","imageRes":"1","image2x":"'+imgPathAfterX2+'","image3x":"'+imgPathAfterX3+'"}'); 
}

//////////////////////
// Custom Functions //
//////////////////////

// Apply New Image Value
function setImage(imgPath,imgRes,attrName)
{	
	if(imgRes == 1) // @1x
	{
		window.webkit.messageHandlers.debug.postMessage("Attr Name "+attrName); // Sync Changes

		var targetImg = targetImageBefore;

		if (attrName == 'after-image') // After Image
		{
			targetImg = targetImageAfter;
		}

		targetImg.attr('src',imgPath);
	}
	else // @2x & @3x
	{
		setHighResImg(imgPath,imgRes,attrName);
	}
	
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Set High Res image
function setHighResImg(imgPath,imgRes,attrName)
{	
	// Dont store actual paths to assets for multi res as they 
	// are not used within Blocs, srcset paths should be set 
	// up for use on export ie. img/myimage.png and 
	// full paths stored to src-2 & src-3 helper attributes which are used 
	// within design enviroment.
	
	var targetImg = targetImageBefore;

	if(attrName == 'after-image') // After Image
	{
		targetImg = targetImageAfter;
	}

	var fileName = getFileExportName(imgPath); // Get Image File Name	
	var srcSetData = targetImg.attr('srcset-blocsapp'); // Retina SRC Data
	var newData = fileName+' '+imgRes+'x';
	
	if(imgRes == 2) // @2x
	{
		if(targetImg.hasAttr('src-3')) // Has @3x Value
		{
			newData += ', '+getFileExportName(targetImg.attr('src-3'))+' 3x';
		}
	}
	else // @3x
	{
		if(targetImg.hasAttr('src-2')) // Has @3x Value
		{
			newData = getFileExportName(targetImg.attr('src-2'))+' 2x, '+ newData;
		}
	}
	
	targetImg.attr('srcset-blocsapp',newData).attr("src-"+imgRes, imgPath); // Set Image
	
	// src-2, src-3 are helper attributes which are used to store the paths 
	// in the design enviroment, these attributes are removed when project is exported. 
}

// Get Image File Export Name
function getFileExportName(imgPath)
{	
	var fileName = 'img/'+imgPath.split('/').pop();
	
	if(imgPath.substring(0,4) == 'http')
	{
		fileName = imgPath;
	}
	
	return fileName;
}


// Set Image Alt Value
function setAltValue(V,attrName)
{
	var targetImg = targetImageBefore;

	if(attrName == 'after-image-alt') // After Image
	{
		targetImg = targetImageAfter;
	}

	targetImg.attr('alt',V);
	window.webkit.messageHandlers.sync.postMessage("changes"); // sync Changes
}


/////////////
// Plugins //
/////////////


// Has Attribute
$.fn.hasAttr = function(name){  
   return this.attr(name) !== undefined;
};